/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

	icl "Kaz_Lew.h"

	org $f0

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

WIDTH	= 48
HEIGHT	= 30

; ---	BASIC switch OFF
	org $2000\ mva #$ff $D301\ rts\ ini $2000

; ---	MAIN PROGRAM
	org $2000
ant	dta $44,a(scr)
	dta $04,$84,$04,$04,$84,$04,$84,$04,$84,$04,$84,$04,$84,$04,$84,$04
	dta $04,$84,$04,$84,$04,$04,$84,$84,$84,$84,$84,$84,$04
	dta $41,a(ant)

scr	ins "Kaz_Lew.scr"

	.ds 0*40

	.ALIGN $0400
fnt	ins "Kaz_Lew.fnt"

	ift USESPRITES
	.ALIGN $0800
pmg	.ds $0300
	ift FADECHR = 0
	SPRITES
	els
	.ds $500
	eif
	eif

main
; ---	init PMG

	ift USESPRITES
	mva >pmg $D407		;missiles and players data address
	mva #$03 $D01D		;enable players and missiles
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 $D40E		;stop NMI interrupts
	sta $D400
	mva #$fe $D301		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 $D40E		;switch on NMI+DLI again

	ift CHANGES		;if label CHANGES defined

_lp	lda $D010		; FIRE #0
	beq stop

	lda $D011		; FIRE #1
	beq stop

	lda $D01F		; START
	and #1
	beq stop

	lda $D20F
	and #$04
	bne _lp			;wait to press any key; here you can put any own routine

	els

null	jmp DLI.dli1		;CPU is busy here, so no more routines allowed

	eif


stop
	mva #$00 $D01D		;PMG disabled
	tax
	sta:rne $D000,x+

	mva #$ff $D301		;ROM switch on
	mva #$40 $D40E		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled

	rts			;return to ... DOS

; ---	DLI PROGRAM

.local	DLI

	?old_dli = *

	ift !CHANGES

dli1	lda $D010		; FIRE #0
	beq stop

	lda $D011		; FIRE #1
	beq stop

	lda $D01F		; START
	and #1
	beq stop

	lda $D20F
	and #$04
	beq stop

	lda $D40B
	cmp #$02
	bne dli1

	:3 sta $D40A

	DLINEW DLI.dli2
	eif


dli_start

dli2
	sta regA
	lda >fnt+$400*$01
	sta $D40A		;line=24
	sta $D409
	DLINEW dli3 1 0 0

dli3
	sta regA
	lda >fnt+$400*$02
	sta $D40A		;line=48
	sta $D409
	DLINEW dli4 1 0 0

dli4
	sta regA
	lda >fnt+$400*$03
	sta $D40A		;line=64
	sta $D409
	DLINEW dli5 1 0 0

dli5
	sta regA
	lda >fnt+$400*$04
	sta $D40A		;line=80
	sta $D409
	DLINEW dli6 1 0 0

dli6
	sta regA
	lda >fnt+$400*$05
	sta $D40A		;line=96
	sta $D409
	DLINEW dli7 1 0 0

dli7
	sta regA
	lda >fnt+$400*$06
	sta $D40A		;line=112
	sta $D409
	DLINEW dli8 1 0 0

dli8
	sta regA
	lda >fnt+$400*$07
	sta $D40A		;line=128
	sta $D409
	DLINEW dli9 1 0 0

dli9
	sta regA
	lda >fnt+$400*$08
	sta $D40A		;line=152
	sta $D409
	DLINEW dli10 1 0 0

dli10
	sta regA
	lda >fnt+$400*$09
	sta $D40A		;line=168
	sta $D409
	DLINEW dli11 1 0 0

dli11
	sta regA
	lda >fnt+$400*$0A
	sta $D40A		;line=192
	sta $D409
	DLINEW dli12 1 0 0

dli12
	sta regA
	lda >fnt+$400*$02
	sta $D40A		;line=200
	sta $D409
	DLINEW dli13 1 0 0

dli13
	sta regA
	lda >fnt+$400*$03
	sta $D40A		;line=208
	sta $D409
	DLINEW dli14 1 0 0

dli14
	sta regA
	lda >fnt+$400*$04
	sta $D40A		;line=216
	sta $D409
	DLINEW dli15 1 0 0

dli15
	sta regA
	lda >fnt+$400*$05
	sta $D40A		;line=224
	sta $D409
	DLINEW dli16 1 0 0

dli16
	sta regA
	lda >fnt+$400*$00
	sta $D40A		;line=232
	sta $D409

	lda regA
	rti

.endl

; ---

CHANGES = 1
FADECHR	= 0

SCHR	= 127

; ---

.proc	NMI

	bit $D40F
	bpl VBL

	jmp DLI.dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta $D40F		;reset NMI flag

	mwa #ant $D402		;ANTIC address program

	mva #$3F $D400	;set new screen width

	inc cloc		;little timer

; Initial values

	lda >fnt+$400*$00
	sta $D409
c0	lda #$00
	sta $D01A
	sta $D016
c1	lda #$0E
	sta $D017
c2	lda #$00
	sta $D018
	sta $D019
	lda #$02
	sta $D401
	lda #$01
	sta $D01B
s0	lda #$00
	sta $D00B
x0	lda #$96
	sta $D003
c3	lda #$E4
	sta $D015
s1	lda #$00
	sta $D00A
x1	lda #$C3
	sta $D002
c4	lda #$E4
	sta $D014
x2	lda #$00
	sta $D000
	sta $D001
	sta $D004
	sta $D005
	sta $D006
	sta $D007
	sta $D008
	sta $D009
	sta $D00C
	sta $D012
	sta $D013

	mwa #DLI.dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

; ---
	ini main
; ---

	opt l-

.MACRO	SPRITES
missiles
	.ds $100
player0
	.ds $100
player1
	.ds $100
player2
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 1C 3E
	.he 7F 7F 7F 7F 7F 7F 7F 7F 7F 7E 3C 18 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player3
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 38 7C 7E FE FE FF FF
	.he FF FF FF FF FF 7E 3C 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
.ENDM

USESPRITES = 1

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

